//########################
/*■■■このスクリプトについて■■■
g-xml形式の数値地図データをIllustratorドキュメントに再現します。
うまくいかないときは拡大率や座標がアートボードからはみ出している場合も考えられます。
下の値ぐらいに変更して試してみてください。
var myper = 0.01;//拡大率
var xoffset = 0;//X座標の移動値
var yoffset = 0;//Y座標の移動値
たぶんIllustratorCS4でも動くと思います。
■■■数値地図のダウンロード方法■■■
「独立行政法人統計センター」のホームページから数値地図をダウンロードします。
http://www.e-stat.go.jp/SG1/estat/eStatTopPortal.do
から「地図で見る統計（統計ＧＩＳ）」をクリックします。
次の画面で「データダウンロード」をクリックします。

データダウンロードで平成17年度国勢調査（小地域）を選択します。
右側はなんでもかまいませんので選択し「次へ」をクリックします。

次の画面で地域を選択して「検索」をクリックします。
右側に表示される
「世界測地系平面直角座標系・G-XML形式」か
「世界測地系緯度経度・G-XML形式」を選択してダウンロードします。*/
//たけうちとおる
//########################
var myper = 0.1;//拡大率
var xoffset;//X座標の移動値（自動判定）
var yoffset;//Y座標の移動値（自動判定）

main();

function main(){
	if( app.documents.length == 0){
		alert("ドキュメントを開いて実行してください。");
		return;
	}
	fileObj = File.openDialog("xmlファイルを選択してください");
	if(fileObj){
		openmif(fileObj);
	}
	alert("終了しました");
}

function openmif(fileObj){
	flag = fileObj.open("r");
	if (flag == true){
		var myFlg = -2;
		while (!fileObj.eof){
			var mystr = fileObj.read();
		}
		fileObj.close();
		var myXml = mystr.split("<GeometricFeature");
		var outline= getArea(myXml[1]);
		var pointAry = outline[0].split(",");
		var testX = eval(pointAry[0])*myper;
		var testY = eval(pointAry[1])*myper;
		xoffset = -testX+500;
		yoffset = -testY+500;
		for(var N = 1 ; N < myXml.length;N++){
			var outline= getArea(myXml[N]);
			var outline2= getinnerArea(myXml[N]);
			var mojiname = getProperty(myXml[N]);
			var layerName = mojiname;
			makeentirepath(outline,layerName);
			makeentirepath(outline2,layerName);
		}
	}
}

function makeentirepath(outline,layerName){
		var pathcount = outline.length;
		if(pathcount > 1){
			shapeAry = new Array(pathcount-1);
			for( N = 0; N < pathcount-1; N++){
				pointAry = outline[N].split(",");
				shapeAry[N] = [eval(pointAry[0])*myper+xoffset,eval(pointAry[1])*myper+yoffset];
			}
			makeshape(shapeAry,layerName);
		}
}

function makeshape(myentirepath,layerName){
	var myColor = reColor( Math.floor(Math.random() * 100) + 1,Math.floor(Math.random() * 100) + 1,Math.floor(Math.random() * 100) + 1,0); //　赤色
	try{
		var layerObj = app.activeDocument.layers[layerName];
	}catch(err){
		var layerObj = app.activeDocument.layers.add();
		layerObj.name = layerName;
	}
	try{
	pObj = layerObj.pathItems.add();
	pObj.setEntirePath(myentirepath);
	pObj.filled =  true; //　塗りなし
	pObj.stroked = false; //　線あり
	pObj.fillColor = myColor; //　塗りの色を指定（赤色）
	pObj.closed = true;
	}catch(err){
		layerObj.name = ""+layerName;
	}
	//pObj.strokeWidth = 3; //　線幅10ポイント
	//pObj.strokeColor = redColor; //　線の色を指定（赤色）
}

function reColor(C,M,Y,K){
	var myCMYK=new CMYKColor();
	//var myColor=new Color();
	
	myCMYK.cyan=C;
	myCMYK.magenta=M;
	myCMYK.yellow=Y;
	myCMYK.black=K;
	
	//myColor.cmyk=myCMYK;
	return myCMYK;
}

function getArea(moto){
	var matches = "";
	xx = moto.match(/<Geometry><Polygon><OuterBoundary><LinearRing><Coordinates unit.location="m">([^<]*)</);
	if(xx != null){
		matches = xx[1];
		var myArea=matches.split(" ");
	}else{
		var myArea = "";
	}
	return myArea;
}

function getinnerArea(moto){
	var matches = "";
	xx = moto.match(/<InnerBoundary><LinearRing><Coordinates unit.location="m">([^<]*)</);
	if(xx != null){
		matches = xx[1];
		var myArea=matches.split(" ");
	}else{
		var myArea = "";
	}
	return myArea;
}

function getProperty(moto){
	//var kenname = getProperty(myXml[N],"KEN_NAME");
	//var gstname = getProperty(myXml[N],"GST_NAME");
	//var mojiname = getProperty(myXml[N],"MOJI");
	var matches = "";
	xx = moto.match(/<Property propertytypename="KEN_NAME" datatype="[a-z]*">([^<]*)</);
	if(xx != null){
		matches = xx[1];
	}
	xx = moto.match(/<Property propertytypename="GST_NAME" datatype="[a-z]*">([^<]*)</);
	if(xx != null){
		matches = matches + xx[1];
	}
	xx = moto.match(/<Property propertytypename="MOJI" datatype="[a-z]*">([^<]*)</);
	if(xx != null){
		matches = matches + xx[1];
	}
	return matches;
}